// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'igBaseModel.pas' rev: 4.00

#ifndef igBaseModelHPP
#define igBaseModelHPP

#pragma delphiheader begin
#pragma option push -w-
#include <igModelConverter.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Igbasemodel
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TTopBound { bnFirst, bnGreaterOrEqual, bnGreater };
#pragma option pop

#pragma option push -b-
enum TBottomBound { bnLast, bnLessOrEqual, bnLess };
#pragma option pop

class DELPHICLASS TigCompareModel;
class DELPHICLASS TigCompareItem;
#pragma option push -b-
enum TigCompareItemValue { civCompareKey, civName, civDisplayLabel };
#pragma option pop

typedef Set<TigCompareItemValue, civCompareKey, civDisplayLabel>  TigCompareItemValues;

class DELPHICLASS TigBaseModel;
class DELPHICLASS TigCompareItems;
#pragma option push -b-
enum TigItemUpdateOption { ioCreate, ioDestroy, ioCompareKey, ioOptions, ioValue, ioName, ioDataType 
	};
#pragma option pop

typedef Set<TigItemUpdateOption, ioCreate, ioDataType>  TigItemUpdateOptions;

typedef TMetaClass*TigCompareItemClass;

__interface IItemListener;
typedef System::DelphiInterface<IItemListener> _di_IItemListener;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TigCompareItems : public Classes::TCollection 
{
	typedef Classes::TCollection inherited;
	
private:
	TigBaseModel* FBaseModel;
	Classes::TList* FItemListeners;
	TigItemUpdateOptions FItemUpdateOptions;
	HIDESBASE TigCompareItem* __fastcall GetItem(int Index);
	HIDESBASE void __fastcall SetItem(int Index, TigCompareItem* Value);
	void __fastcall FireItemDeleting(TigCompareItem* Item);
	void __fastcall FireItemDataTypeChanged(TigCompareItem* Item);
	
protected:
	virtual void __fastcall Update(Classes::TCollectionItem* Item);
	virtual void __fastcall FireItemEvent(TigCompareItem* Item);
	
public:
	__fastcall TigCompareItems(TigBaseModel* IgBaseModel, TMetaClass* CompareItemClass);
	__fastcall virtual ~TigCompareItems(void);
	void __fastcall ClearValues(void);
	TigCompareItem* __fastcall FindByName(const AnsiString Name);
	TigCompareItem* __fastcall FindItem(const AnsiString Name);
	DYNAMIC Classes::TPersistent* __fastcall GetOwner(void);
	HIDESBASE TigCompareItem* __fastcall Add(void);
	void __fastcall AddItemListener(_di_IItemListener ItemListener);
	void __fastcall RemoveItemListener(_di_IItemListener ItemListener);
	__property TigBaseModel* BaseModel = {read=FBaseModel};
	__property TigCompareItem* Items[int Index] = {read=GetItem, write=SetItem/*, default*/};
};

#pragma pack(pop)

#pragma option push -b-
enum TigItemsOption { ioCustom, ioDefault };
#pragma option pop

class DELPHICLASS TigCompareModelList;
typedef TMetaClass*TigCompareModelClass;

struct TigCompareModelItem;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TigCompareModelList : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	Classes::TList* FList;
	int __fastcall FindItem(int Key);
	int __fastcall GetCount(void);
	
public:
	__fastcall virtual TigCompareModelList(void);
	__fastcall virtual ~TigCompareModelList(void);
	void __fastcall Add(int Key, AnsiString Caption, TMetaClass* CompareModelClass);
	TigCompareModelItem __fastcall Remove(int Key);
	TigCompareModelItem __fastcall Get(int Key);
	int __fastcall GetKey(int Index);
	TigCompareModelItem __fastcall GetValue(int Index);
	void __fastcall Clear(void);
	__property int Count = {read=GetCount, nodefault};
};

#pragma pack(pop)

class DELPHICLASS TigModelOptions;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TigModelOptions : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	TigBaseModel* FBaseModel;
	bool FAutoUpdate;
	bool FChangeCursor;
	
protected:
	__property TigBaseModel* BaseModel = {read=FBaseModel};
	
public:
	__fastcall TigModelOptions(TigBaseModel* BaseModel);
	
__published:
	__property bool ChangeCursor = {read=FChangeCursor, write=FChangeCursor, default=1};
	__property bool AutoUpdate = {read=FAutoUpdate, write=FAutoUpdate, default=1};
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TigModelOptions(void) { }
	#pragma option pop
	
};

#pragma pack(pop)

#pragma option push -b-
enum TigUpdateLevel { ulNone, ulLow, ulHigh };
#pragma option pop

#pragma option push -b-
enum igBaseModel__9 { bsLoading, bsSetItems, bsApplying, bsDisableFullUpdate };
#pragma option pop

typedef Set<igBaseModel__9, bsLoading, bsDisableFullUpdate>  TigBaseModelState;

__interface IigCalculateModel;
typedef System::DelphiInterface<IigCalculateModel> _di_IigCalculateModel;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TigBaseModel : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	TigCompareItems* FCompareItems;
	TigItemsOption FItemsOption;
	TigCompareModelList* FCompareModelList;
	TigModelOptions* FOptions;
	TigUpdateLevel FUpdateLevel;
	TigCompareItem* FChangedItem;
	System::TObject* FCalculateModel;
	TigBaseModelState FBaseModelState;
	int FDisableFullUpdateCount;
	void __fastcall SetItemsOption(TigItemsOption Value);
	bool __fastcall IsCompareItemsStored(void);
	AnsiString __fastcall GetExpression(void);
	void __fastcall SetExpression(AnsiString Value);
	void __fastcall SetItemsData(void);
	void __fastcall SetLightItemsData(void);
	_di_IigCalculateModel __fastcall GetCalculateModel(void);
	
protected:
	DYNAMIC void __fastcall CreateCompareModelList(/* out */ TigCompareModelList* &CompareModelList) = 0 
		;
	DYNAMIC void __fastcall CreateCompareItems(/* out */ TigCompareItems* &CompareItems) = 0 ;
	DYNAMIC void __fastcall CreateOptions(/* out */ TigModelOptions* &Options);
	virtual void __fastcall UpdateDataBeforeApply(void);
	virtual void __fastcall SetItems(void);
	virtual void __fastcall SetDefaultItemsData(void);
	virtual bool __fastcall GetActive(void);
	virtual void __fastcall Loaded(void);
	virtual void __fastcall UpdateItem(TigCompareItem* Item);
	virtual bool __fastcall InternalApply(void) = 0 ;
	__property _di_IigCalculateModel CalculateModel = {read=GetCalculateModel};
	__property TigCompareModelList* CompareModelList = {read=FCompareModelList};
	__property TigModelOptions* Options = {read=FOptions, write=FOptions};
	__property TigUpdateLevel UpdateLevel = {read=FUpdateLevel, write=FUpdateLevel, nodefault};
	
public:
	__fastcall virtual TigBaseModel(Classes::TComponent* AOwner);
	__fastcall virtual ~TigBaseModel(void);
	bool __fastcall Apply(void);
	bool __fastcall CheckItems(void);
	void __fastcall DisableFullUpdate(void);
	void __fastcall EnableFullUpdate(void);
	__property bool Active = {read=GetActive, nodefault};
	__property TigBaseModelState BaseModelState = {read=FBaseModelState, nodefault};
	
__published:
	__property TigCompareItems* CompareItems = {read=FCompareItems, write=FCompareItems, stored=IsCompareItemsStored
		};
	__property TigItemsOption ItemsOption = {read=FItemsOption, write=SetItemsOption, default=1};
	__property AnsiString Expression = {read=GetExpression, write=SetExpression};
};

#pragma pack(pop)

#pragma option push -b-
enum TigCompareItemOption { ciCaseInsensitive, ciCompareIfEmpty, ciConvertValue };
#pragma option pop

typedef Set<TigCompareItemOption, ciCaseInsensitive, ciConvertValue>  TigCompareItemOptions;

#pragma pack(push, 4)
class PASCALIMPLEMENTATION TigCompareItem : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
private:
	TigCompareItemValues FAssignedValues;
	TigBaseModel* FBaseModel;
	int FCompareKey;
	Variant FBufferValue;
	AnsiString FName;
	TigCompareModel* FCompareModel;
	TigCompareItemOptions FOptions;
	Word FDataType;
	int FDataSize;
	AnsiString FDisplayLabel;
	void __fastcall IncludeAssignedValues(const TigCompareItemValue Value);
	void __fastcall SetCompareKey(int Value);
	void __fastcall SetValue(AnsiString Value);
	AnsiString __fastcall GetValue(void);
	void __fastcall SetOptions(TigCompareItemOptions Value);
	void __fastcall SetAsVariant(const Variant &Value);
	AnsiString __fastcall CalculateDefaultName(AnsiString Name, int N);
	bool __fastcall CheckDuplicateName(AnsiString Value);
	void __fastcall InternalSetValue(const Variant &Value, const bool UpdateValue);
	bool __fastcall IsCompareKeyStored(void);
	bool __fastcall IsOptionsStored(void);
	bool __fastcall IsDisplayLabelStored(void);
	AnsiString __fastcall GetDefaultName(void);
	void __fastcall SetPrivateName(const AnsiString Value, const bool Assigned);
	void __fastcall SetPrivateCompareKey(const int Value, bool Assigned);
	void __fastcall SetCompareModel(const int CompareKey);
	void __fastcall SetDisplayLabel(const AnsiString Value);
	AnsiString __fastcall GetDisplayLabel(void);
	void __fastcall SetAsDateTime(System::TDateTime Value);
	System::TDateTime __fastcall GetAsDateTime(void);
	__int64 __fastcall GetAsLargeint(void);
	void __fastcall SetAsLargeint(__int64 Value);
	AnsiString __fastcall GetAsString(void);
	void __fastcall SetAsString(AnsiString Value);
	void __fastcall SetAsInteger(int Value);
	int __fastcall GetAsInteger(void);
	void __fastcall SetAsBoolean(bool Value);
	bool __fastcall GetAsBoolean(void);
	void __fastcall SetAsFloat(double Value);
	double __fastcall GetAsFloat(void);
	System::Currency __fastcall GetAsCurrency(void);
	void __fastcall SetAsCurrency(System::Currency Value);
	
protected:
	void __fastcall CompareItemChanged(const TigItemUpdateOption UpdateOption);
	virtual void __fastcall UpdateData(void);
	virtual void __fastcall LightUpdateData(void);
	virtual int __fastcall DefaultCompareKey(void);
	virtual TigCompareItemOptions __fastcall DefaultOptions(void);
	virtual AnsiString __fastcall DefaultDisplayLabel(void);
	virtual bool __fastcall GetActive(void);
	void __fastcall SetDataType(Word DataType, int DataSize);
	virtual Variant __fastcall GetCompareAsVariant(void) = 0 ;
	virtual AnsiString __fastcall GetCompareAsString(void) = 0 ;
	virtual AnsiString __fastcall GetDisplayName(void);
	virtual void __fastcall SetName(AnsiString Value);
	virtual AnsiString __fastcall GetName(void);
	virtual void __fastcall SetFieldName(AnsiString Value);
	virtual AnsiString __fastcall GetFieldName(void);
	virtual AnsiString __fastcall DefaultName(void);
	
public:
	__fastcall virtual TigCompareItem(Classes::TCollection* Collection);
	__fastcall virtual ~TigCompareItem(void);
	bool __fastcall IsAgree(void);
	bool __fastcall IsEmpty(void);
	__property bool Active = {read=GetActive, nodefault};
	__property TigBaseModel* BaseModel = {read=FBaseModel};
	__property Variant AsVariant = {read=FBufferValue, write=SetAsVariant, stored=false};
	__property System::TDateTime AsDateTime = {read=GetAsDateTime, write=SetAsDateTime, stored=false};
	__property __int64 AsLargeInt = {read=GetAsLargeint, write=SetAsLargeint, stored=false};
	__property AnsiString AsString = {read=GetAsString, write=SetAsString, stored=false};
	__property int AsInteger = {read=GetAsInteger, write=SetAsInteger, stored=false, nodefault};
	__property bool AsBoolean = {read=GetAsBoolean, write=SetAsBoolean, stored=false, nodefault};
	__property double AsFloat = {read=GetAsFloat, write=SetAsFloat, stored=false};
	__property System::Currency AsCurrency = {read=GetAsCurrency, write=SetAsCurrency, stored=false};
	__property TigCompareModel* CompareModel = {read=FCompareModel};
	__property int DataSize = {read=FDataSize, nodefault};
	__property Word DataType = {read=FDataType, nodefault};
	__property AnsiString FieldName = {read=GetFieldName, write=SetFieldName};
	
__published:
	__property AnsiString DisplayLabel = {read=GetDisplayLabel, write=SetDisplayLabel, stored=IsDisplayLabelStored
		};
	__property int CompareKey = {read=FCompareKey, write=SetCompareKey, stored=IsCompareKeyStored, nodefault
		};
	__property TigCompareItemOptions Options = {read=FOptions, write=SetOptions, stored=IsOptionsStored
		, nodefault};
	__property AnsiString Value = {read=GetValue, write=SetValue};
	__property AnsiString Name = {read=GetName, write=SetName};
};

#pragma pack(pop)

#pragma pack(push, 4)
class PASCALIMPLEMENTATION TigCompareModel : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	TigCompareItem* FCompareItem;
	Variant FValue;
	bool FCaseInsensitive;
	Word FVarType;
	int FSize;
	bool FIsConverted;
	Variant FConvertedValue;
	void __fastcall DoDataChange(void);
	AnsiString __fastcall GetFieldName(void);
	
protected:
	virtual void __fastcall DataChanged(void);
	virtual Variant __fastcall GetTopBoundValue(void);
	virtual Variant __fastcall GetBottomBoundValue(void);
	virtual void __fastcall SetConvertedValue(const Variant &Value);
	virtual void __fastcall SetIsConverted(bool Value);
	
public:
	__fastcall TigCompareModel(void);
	Variant __fastcall GetCompareAsVariant(void);
	AnsiString __fastcall GetCompareAsString(void);
	virtual bool __fastcall IsAgree(void) = 0 ;
	virtual AnsiString __fastcall GetSqlExpression(void);
	virtual bool __fastcall IsParam(void);
	AnsiString __fastcall GetParamName(void);
	__property Variant TopBoundValue = {read=GetTopBoundValue};
	__property Variant BottomBoundValue = {read=GetBottomBoundValue};
	__property Variant Value = {read=FValue};
	__property Word VarType = {read=FVarType, nodefault};
	__property bool CaseInsensitive = {read=FCaseInsensitive, nodefault};
	__property int Size = {read=FSize, nodefault};
	__property AnsiString FieldName = {read=GetFieldName};
	__property bool IsConverted = {read=FIsConverted, write=SetIsConverted, nodefault};
	__property Variant ConvertedValue = {read=FConvertedValue, write=SetConvertedValue};
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TigCompareModel(void) { }
	#pragma option pop
	
};

#pragma pack(pop)

#pragma pack(push, 4)
struct TigCompareModelItem
{
	AnsiString Caption;
	TMetaClass*CompareModelClass;
} ;
#pragma pack(pop)

__interface IItemListener  : public IUnknown /* __guid="{9C215033-B6CD-4B39-9F90-CEBC52F19627}" */
{
	
public:
	virtual void __fastcall ItemAdded(TigCompareItem* CompareItem) = 0 ;
	virtual void __fastcall ItemDeleting(TigCompareItem* CompareItem) = 0 ;
	virtual void __fastcall ItemValueChanged(TigCompareItem* CompareItem) = 0 ;
	virtual void __fastcall ItemDataTypeChanged(TigCompareItem* CompareItem) = 0 ;
};

class DELPHICLASS TBaseNode;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TBaseNode : public System::TObject 
{
	typedef System::TObject inherited;
	
public:
	virtual bool __fastcall IsAgree(void) = 0 ;
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TBaseNode(void) : System::TObject() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TBaseNode(void) { }
	#pragma option pop
	
};

#pragma pack(pop)

__interface IigCalculateModel  : public IItemListener /* __guid="{F387793D-3586-4C9F-BA24-617D1111643B}" */
	
{
	
public:
	virtual void __fastcall SetExpression(AnsiString Value) = 0 ;
	virtual AnsiString __fastcall GetExpression(void) = 0 ;
	virtual void __fastcall PreCompile(void) = 0 ;
	virtual bool __fastcall Calculate(void) = 0 ;
	virtual TBaseNode* __fastcall GetNode(void) = 0 ;
};

class DELPHICLASS TObjectInterface;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TObjectInterface : public System::TObject 
{
	typedef System::TObject inherited;
	
public:
	HRESULT __stdcall QueryInterface(const GUID &IID, /* out */ void *Obj);
	int __stdcall _AddRef(void);
	int __stdcall _Release(void);
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TObjectInterface(void) : System::TObject() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TObjectInterface(void) { }
	#pragma option pop
	
private:
	void *__IUnknown;	/* IUnknown */
	
public:
	operator IUnknown*(void) { return (IUnknown*)&__IUnknown; }
	
};

#pragma pack(pop)

class DELPHICLASS TPersistentInterface;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TPersistentInterface : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
__published:
	HRESULT __stdcall QueryInterface(const GUID &IID, /* out */ void *Obj);
	int __stdcall _AddRef(void);
	int __stdcall _Release(void);
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TPersistentInterface(void) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TPersistentInterface(void) : Classes::TPersistent() { }
	#pragma option pop
	
private:
	void *__IUnknown;	/* IUnknown */
	
public:
	operator IUnknown*(void) { return (IUnknown*)&__IUnknown; }
	
};

#pragma pack(pop)

#pragma option push -b-
enum TEventType { etAdd, etDeleting, etValueChange, etDataTypeChange };
#pragma option pop

class DELPHICLASS EigBaseModelError;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION EigBaseModelError : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	#pragma option push -w-inl
	/* Exception.Create */ inline __fastcall EigBaseModelError(const AnsiString Msg) : Sysutils::Exception(
		Msg) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall EigBaseModelError(const AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall EigBaseModelError(int Ident, Extended Dummy) : Sysutils::Exception(
		Ident, Dummy) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall EigBaseModelError(int Ident, const System::TVarRec * 
		Args, const int Args_Size) : Sysutils::Exception(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall EigBaseModelError(const AnsiString Msg, int AHelpContext
		) : Sysutils::Exception(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall EigBaseModelError(const AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall EigBaseModelError(int Ident, int AHelpContext) : Sysutils::Exception(
		Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall EigBaseModelError(int Ident, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Ident, Args, Args_Size, AHelpContext
		) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~EigBaseModelError(void) { }
	#pragma option pop
	
};

#pragma pack(pop)

//-- var, const, procedure ---------------------------------------------------
static const Shortint cEqual = 0x0;
static const Shortint cNotEqual = 0x1;
static const Shortint cGreater = 0x2;
static const Shortint cGreaterOrEqual = 0x3;
static const Shortint cLess = 0x4;
static const Shortint cLessOrEqual = 0x5;
static const Shortint cStarts = 0x6;
static const Shortint cNotStarts = 0x7;
static const Shortint cEnds = 0x8;
static const Shortint cNotEnds = 0x9;
static const Shortint cContains = 0xa;
static const Shortint cNotContains = 0xb;
static const Shortint cPattern = 0xc;
static const Shortint cNotPattern = 0xd;
static const Shortint cNull = 0xe;
static const Shortint cNotNull = 0xf;
static const Shortint cMore = 0x2;
static const Shortint cMoreOrEqual = 0x3;
extern PACKAGE void __fastcall igBaseModelError(const AnsiString Message, Classes::TComponent* Component
	);
extern PACKAGE void __fastcall igBaseModelErrorFmt(const AnsiString Message, const System::TVarRec * 
	Args, const int Args_Size, Classes::TComponent* Component);

}	/* namespace Igbasemodel */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Igbasemodel;
#endif
#pragma option pop	// -w-

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// igBaseModel
